#include <iostream>
#include <string>

class Demo {
public:
    Demo(std::string s) {
        std::cout << "constructor" << std::endl;
        a_ptr = new std::string;
        *a_ptr = s;
    }
    
    Demo(const Demo& obj) {
        std::cout << "copy constructor" << std::endl;
        a_ptr = new std::string;
        *a_ptr = *obj.a_ptr;
    }
    
    void set_a(std::string s) {
        *a_ptr = s;
    }
    
    void do_something() {
        std::cout << *a_ptr << std::endl;
    }
    
private:
    std::string *a_ptr;
};

int main() {
    Demo d1("There is no spoon.");
    d1.do_something();
    Demo d2 = d1;
    d2.do_something();
    
    d1.set_a("What's truth?");
    d1.do_something();
    d2.do_something();
    
    return 0;
}

/* 《程式語言教學誌》的範例程式
   https://kaiching.org/
   檔名：u0914.cpp
   功能：示範 C++ 的類別
   作者：張凱慶*/